## acl2 8.6+dfsg

=== Makefile ===
#
# UNIX makefile for building anldp
#
# New-style function declarations are used, so older C compilers might not work.
# On non-BSD systems (Solaris), the following line might have to be removed.

DFLAGS = -DTP_RUSAGE -DTP_HOST

#C compiler
CC = cc

# save symbols for dbx
# CFLAGS = -g -Wall $(DFLAGS)
# CFLAGS = -g $(DFLAGS)

# optimized
CFLAGS = -O $(DFLAGS)

# gprof profiling
# CFLAGS = -pg -O $(DFLAGS)

FILES =    clocks.c avail.c options.c stats.c misc.c dp.c generate.c

OBJECTS =  clocks.o avail.o options.o stats.o misc.o dp.o generate.o

anldp: main.o $(OBJECTS)
	$(CC) $(CFLAGS) -o anldp main.o $(OBJECTS)
	./Configure

clean:
	/bin/rm -f *.o

realclean:
	/bin/rm -f *.o anldp mace mace-loop examples/*/*.out *~ */*~

main.o $(OBJECTS): Header.h
main.o $(OBJECTS): Clocks.h
main.o $(OBJECTS): Avail.h
main.o $(OBJECTS): Options.h
main.o $(OBJECTS): Stats.h
main.o dp.o: Dp.h
