=== books/coi/pattern-hint/Makefile ===
ACL2_SYSTEM_BOOKS ?= ../..

all:
	${ACL2_SYSTEM_BOOKS}/build/cert.pl *.lisp

%.cert : %.lisp
	${ACL2_SYSTEM_BOOKS}/build/cert.pl $*.lisp

clean:
	${ACL2_SYSTEM_BOOKS}/build/clean.pl
