=== books/tools/book-conflicts/Makefile ===
##
## Copyright (C) 2014, David Greve
## License: A 3-clause BSD license.
## See the LICENSE file distributed with ACL2.
##

include ../../Makefile-generic
include MOREDEPS

books: conflicts.cert bookdata-types.cert

conflicts.cert: bookdata-types.cert

clean: cleanup

all: conflicts_img books
