=== debian/changelog ===
acl2 (8.6+dfsg-3) unstable; urgency=medium

  * build-dep latest gcl
  * lintian cleanups
  * Bug fix: "Includes non-free RFC again", thanks to Bastian Germann
    (Closes: #1083157).
  * Bug fix: "add support for loongarch64", thanks to zhangdandan (Closes:
    #1061384).
  * Bug fix: "ftbfs with GCC-15", thanks to Matthias Klose (Closes:
    #1096276).
  * Bug fix: "not handling nostrip build option (policy 10.1) sid/i386",
    thanks to Julien Danjou (Closes: #436372).  nostrip obsolete in favor
    of dh_strip/dbgsym, no longer mentioned in policy.

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 08:36:42 -0400

acl2 (8.6+dfsg-2) unstable; urgency=high

  * set HOME in infix-stamp

 -- Camm Maguire <camm@debian.org>  Sun, 27 Apr 2025 08:32:18 -0400

acl2 (8.6+dfsg-1) unstable; urgency=high

  * New upstream release
  * build depend gcl27

 -- Camm Maguire <camm@debian.org>  Fri, 25 Apr 2025 09:15:16 -0400

acl2 (8.5dfsg-7) unstable; urgency=medium

  * Bug fix: "Includes non-free RFC again", thanks to Bastian Germann
    (Closes: #1083157).
  * Bug fix: "add support for loongarch64", thanks to zhangdandan (Closes:
    #1061384).
  * lintian override context fixes
  * acl2-infix depends on c-shell
  * remove rfc2388.txt even though unnecessary as I cannot get a reply
    from ftpmaster, and they have an automatic reject on this lintian note
    even though overriden

 -- Camm Maguire <camm@debian.org>  Fri, 25 Oct 2024 10:35:08 -0400
