=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

# ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION:=500000000
# MAXJOBS:=$(shell gcl -batch -eval \
#    "(print \
#       (multiple-value-bind (a b c d) (si::heap-report) \
# 	(min 8 \
# 	     (ceiling (/ (- d c) (/ a 8)) \
#                       ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}))))")

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
# NUMJOBS:=$(shell if test $(NUMJOBS) -gt ${MAXJOBS}; then echo ${MAXJOBS} ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori:
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/elpa-acl2.elpa: debian/acl2-pkg.el
	find books/interface/emacs -name "*.el" >$@
	find emacs -name "*.el" >>$@
	find books/xdoc -name "*.el" >>$@
	find books/system/doc -name "*.el" >>$@
	find books/emacs -name "*.el" >>$@
	echo debian/acl2.el >> debian/elpa-acl2.elpa
	echo debian/acl2-pkg.el >> debian/elpa-acl2.elpa
	echo debian/debian-autoloads.el >> debian/elpa-acl2.elpa


debian/acl2-pkg.el: debian/acl2-pkg.el.in
	cat $< | sed "s,@VR@,$$(echo $(VR) | sed 's,[a-zA-Z]*,,g'),g" > $@

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2: 

	ACL2_SNAPSHOT_INFO="commit 1c7e6f3564 (tag: post-8.6-for-debian-gcl)" \
	ACL2_SMALL_FIXNUMS=$$(gcl27 -batch -eval '(princ (if (< (si::heap-report) 64) "T" ""))') \
	$(MAKE) GCL_MEM_BOUND=29 GCL_ANSI=t LISP=gcl27 & j=$$! ; tail --retry -f make.log & k=$$! ; wait $$j ; kill $$k
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
#	These take too much memory when run in parallel
#	HOME=$$(pwd) \
#	EXCLUDED_PREFIXES="projects/x86isa/machine/instructions kestrel/x86  kestrel/axe"
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=$$(pwd) \
	$(MAKE) -j $(NUMJOBS) regression-fresh 2>&1 | tee $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=$$(pwd) \
	$(MAKE) regression 2>&1 | tee -a $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#	>$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
#	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
#		for i in $$(find books -name "*.out"); do \
#			if ! [ -e $${i%out}cert ] ; then \
#				echo $$i ; \
#				cat $$i ; \
#			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || true )
	  # gcl -batch -eval \
          #   "(bye \
	  # 	  #-native-reloc 0 \
          #         #+native-reloc \
          #           (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) \
	  # 		 (format t \"certification run with ~s heap words~%\" w) \
	  # 		 (if (< w ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
            -e 's,"user","USER",g' -e 's,"sloop","SLOOP",g' \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && HOME=$$(pwd) $(MAKE) -f Makefile compile
	cd books/interface/infix && HOME=$$(pwd) $(MAKE) -f Makefile example
#	cd books/interface/infix && make -f Makefile events
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: #build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp
	cd books/interface/infix && HOME=$$(pwd) $(MAKE) -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied:
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

OVERRIDES:= $(shell find debian/ -name "*.lintian-overrides.in" |sed 's,\.in,,g')

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) clean-all
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f $(INSTALLS) $(LINKS)
	rm -f books/build/Makefile-sources books/build/Makefile-certs
	rm -f gcl_pool
	rm -f $(OVERRIDES)
	rm -f books/std/strings/binary.cert.temp books/std/strings/decimal.cert.temp books/std/strings/defs-program.cert.temp
	rm -f books/build/defrec-certdeps/*.certdep
	rm -f books/centaur/vl/kit/test.vlzip
	rm -f books/std/io/test.sao
