=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//g,searchmode=plain" https://api.github.com/repos/acl2-devel/acl2-devel/releases?per_page=50 "acl2-(\d.\d)\.tar\.gz"
